// ESigBut.cpp : implementation file
//

//#define	KILLER

#include "stdafx.h"
#include "ESignalTest.h"
#include "ESigBut.h"

#ifdef KILLER
#include "Killer.h"
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define	TF_TIMER_ID			100
#define	TF_TIMER_USEC		1000

#define	ODBG(a)				OutputDebugString(a)

/////////////////////////////////////////////////////////////////////////////
// CESigBut

CESigBut::CESigBut()
{
	m_strUserName	= "JimBecker17";
	m_piHooks 		= NULL;
	m_pEvents 		= NULL;
	m_dwCookie		= 0;
	m_hHist			= 0;

	m_nCount		= 0;
	m_bTimerRunning	= FALSE;
}

CESigBut::~CESigBut()
{
	UnregisterESignal(FALSE);
}


BEGIN_MESSAGE_MAP(CESigBut, CButton)
	//{{AFX_MSG_MAP(CESigBut)
	ON_WM_TIMER()
	ON_CONTROL_REFLECT(BN_CLICKED, OnClicked)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CESigBut message handlers

void CESigBut::Start()
{
	if( !m_bTimerRunning ) {
		RegisterESignal();
	}
}

void CESigBut::Stop()
{
	if( m_bTimerRunning	) {
		UnregisterESignal();
	}
}


void CESigBut::OnTimer(UINT nIDEvent) 
{
	CString		strText;

	if( !m_bTimerRunning )
		return;

	CheckEntitled();
	ES_SetToSymbol( m_strSymbol );
	ES_RequestSymbol( m_strSymbol );

	if( (++m_nCount % 10) == 0 ) {

		strText.Format("%s %d", m_strSymbol, m_nCount );
		SetWindowText(strText);
	}
}



void CESigBut::COMErrorReset(_com_error &e)
{
	static BOOL	bRecurse	= FALSE;

	if( bRecurse ) 
		return;

	bRecurse = TRUE;

	m_bTimerRunning	= FALSE;

	CString tmp;
	tmp.Format("eSignal COM: %s\n", (PCSTR)e.ErrorMessage());

	ODBG(tmp);

	ErrorRestart();

	bRecurse = FALSE;
}

void CESigBut::ErrorRestart()
{
#ifdef KILLER
	CString			strProcA("winsig");
	CString			strProcB("CoreReport");
	CKiller			killer;

	killer.KillProcess( strProcA, strProcB );
#endif // KILLER

	RegisterESignal();
}


void CESigBut::RegisterESignal()
{
    try 
    {
		m_piHooks			= new IHooksPtr("IESignal.Hooks.1");
		m_pEvents 			= new EventSink(this);
		LPUNKNOWN pUnk		= m_pEvents->GetIDispatch(FALSE);


		// establish the connection
		if(AfxConnectionAdvise(*m_piHooks,__uuidof(_IHooksEvents),pUnk,FALSE,&m_dwCookie)) {
			(*m_piHooks)->SetApplication(S2B(m_strUserName));

//			(*m_piHooks)->OpenNewWindow(S2B("OPEN.LAY"),0,0,1024,768,FALSE,S2B("TZOO"));
		}
    } 
    catch (_com_error &e) 
    {
       COMErrorReset(e);
    }

	int				uTick= GetTickCount() % 1000;
	int				uSec = TF_TIMER_USEC + uTick;

	::SetTimer( GetSafeHwnd(), TF_TIMER_ID,  uSec, NULL);

	m_bTimerRunning	= TRUE;
	m_nCount		= 0;

	SetWindowText("Registered");
}

void CESigBut::UnregisterESignal(BOOL bMsg)
{
	::KillTimer( GetSafeHwnd(), TF_TIMER_ID );
	m_bTimerRunning	= FALSE;

	try 
	{
		if(m_pEvents) {
			LPUNKNOWN pUnk=m_pEvents->GetIDispatch(FALSE);
			AfxConnectionUnadvise(*m_piHooks,__uuidof(_IHooksEvents),pUnk,FALSE,m_dwCookie);
		}

		if(m_piHooks) {
			delete m_piHooks;
			m_piHooks = NULL;
		}

		if(m_pEvents) {
			delete m_pEvents;
			m_pEvents = NULL;
		}
    } 
    catch (_com_error &e) 
    {
       COMErrorReset(e);
    }

	if( bMsg )
		SetWindowText("Unregistered");
}

// called sometime after registered to setup rest of eSignal....
void CESigBut::CheckEntitled()
{
	if( !(*m_piHooks)->GetIsEntitled() ) {
		ODBG("NOT Entitled\n");
	}
}

void CESigBut::ES_SetToSymbol( const CString& strSymbol )
{
	if( m_piHooks ) {
	    try {
			(*m_piHooks)->DoSymbolLink(S2B(strSymbol));
	    } 
	    catch (_com_error &e) 
	    {
	       COMErrorReset(e);
	    }
	}
}

void CESigBut::ES_RequestSymbol( const CString& strSymbol )
{
	if( m_hHist != 0 ) return;

	CString				strMsg;
	CString				strInterval("5");
	int					nBars		= 100;

//	strMsg.Format("Request '%s'\n", strSymbol ); ODBG(strMsg);
	try {
		m_hHist			= (*m_piHooks)->GetRequestHistory(S2B(strSymbol), S2B(strInterval), btBARS, nBars,-1,-1);

//		CString s; s.Format("ReqH: %-6s %5d   %05d\n", strSymbol, nBars, m_hHist ); ODBG(s);
    } 
    catch (_com_error &e) {
       COMErrorReset(e);
    }
}

void CESigBut::OnClicked() 
{
	if( m_piHooks == NULL ) {
		RegisterESignal();
	} else {
		UnregisterESignal();
	}
}

/// EVENT LISTENERS

void CESigBut::ES_OnSymbolChanged(CString s) 
{
}

void CESigBut::ES_OnTimeSalesChanged(long l) 
{
}

void CESigBut::ES_OnPlaceOrder(CString s) 
{
}

void CESigBut::ES_OnBarsReceived(long l) 
{
	FillHistory(l);
}

void CESigBut::ES_OnBarsChanged(long l) 
{
	FillHistory(l);
}

void CESigBut::ES_OnQuoteChanged(CString s) 
{
}



// This function handles all bars received and bar updates
void CESigBut::FillHistory(long l) 
{
	CString 			sBar;
	CString 			tmpData;
	long				hData		= l;
	long				i;
	long 				lNumBars;
	BarData 			bd;
	CString				strText;
	int					nCount		= 0;
	static int			nTimes		= 0;

    try  {
		lNumBars = (*m_piHooks)->GetGetNumBars(hData);

		for (i = -(lNumBars-1); i <= 0; i++) {

			bd = (BarData)((*m_piHooks)->GetGetBar(hData, i));

			nCount++;
		}

		if ((*m_piHooks)->GetIsHistoryReady (hData)) {

			(*m_piHooks)->ReleaseHistory(hData);

			if( hData != NULL && nCount ) {
//				strText.Format("%3d: Processed Hist %s %d", ++nTimes, m_strSymbol, nCount );
//				ODBG(strText + "\n");
			}
		}

	}
    catch (_com_error &e) {
       COMErrorReset(e);
    }
}
