#if !defined(AFX_ESIGBUT_H__CEC7D781_6432_4F7B_8AB5_BF14BAECC255__INCLUDED_)
#define AFX_ESIGBUT_H__CEC7D781_6432_4F7B_8AB5_BF14BAECC255__INCLUDED_

#include "EventSink.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ESigBut.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CESigBut window

class CESigBut : public CButton,  public EventSinkListener
{
// Construction
public:
	CESigBut();

// Attributes
public:
	IHooksPtr				*m_piHooks;
	EventSink				*m_pEvents;
	DWORD 		            m_dwCookie;
	CString					m_strUserName;
	CString					m_strSymbol;
	long					m_hHist;
	int						m_nCount;
	BOOL					m_bTimerRunning;

// Operations
public:
	void					Start();
	void					Stop();
	void					SetSymbol(  const CString& Symbol )			{ m_strSymbol = Symbol; m_hHist = 0; };

protected:
	void					RegisterESignal();
	void 					UnregisterESignal(BOOL bMsg = TRUE);
	void 					CheckEntitled();
	void 					COMErrorReset(_com_error &e);
	void					ErrorRestart();
	void 					ES_RequestSymbol( const CString& strSymbol );
	void 					ES_SetToSymbol( const CString& Symbol );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CESigBut)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CESigBut();

	// Generated message map functions
protected:
	//{{AFX_MSG(CESigBut)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnClicked();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	virtual void 			ES_OnSymbolChanged(CString s);
	virtual void 			ES_OnQuoteChanged(CString s);
	virtual void 			ES_OnBarsChanged(long l);
	virtual void 			ES_OnBarsReceived(long l);
	virtual void 			ES_OnPlaceOrder(CString s);
	virtual void 			ES_OnTimeSalesChanged(long l);

	void 					FillHistory(long l);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ESIGBUT_H__CEC7D781_6432_4F7B_8AB5_BF14BAECC255__INCLUDED_)
