// ESignalTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ESignalTest.h"
#include "ESignalTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define	TF_TIMER_ID			100
#define	TF_TIMER_USEC		10000

static char	*pSymbols[] = {
"FFKY","FFLC","FFS","FFSX","FGP","FHCC","FHN","FHR","FHRX","FIA","FIC","FIF",
"FIFG","FIFS","FII","FILE","FINB","FINL","FISI","FISV","FIT","FITB","FIX","FIZ",
"FJC","FKKY","FKL","FL","FLA","FLAG","FLB","FLCN","FLDR","FLE","FLEX","FLI",
"FLIC","FLIR","FLML","FLO","FLOWE","FLPB","FLR","FLS","FLSH","FLT","FLWS","FLXS",
"FLYI","FLYR","FMAR","FMBI","FMC","FMCO","FMD","FMDAY","FMER","FMFC","FMKIQ","FMS",
"FMSB","FMT","FMTI","FMX","FMXI","FNB","FNBF","FNBN","FNBP","FNDT","FNF","FNFG",
"FNFI","FNLC","FNLY","FNM","FNSR","FNT","FNVG","FNX","FO","FOB","FOBB","FOE",
"FON","FONR","FOOT","FORD","FORG","FORM","FORR","FORTY","FOSL","FOX","FPFC","FPIC",
"FPL","FPO","FPTB","FPU","FPWR","FR","FRBK","FRC","FRD","FRE","FRED","FRGB",
"FRGO","FRK","FRME","FRN","FRNT","FRO","FRS","FRSH","FRT","FRX","FS","FSBI",
"FSBK","FSCI","FSH","FSI","FSII","FSM","FSNM","FSRV","FSS","FST","FSTR","FSTW",
"FTBK","FTE","FTEK","FTFC","FTG","FTGX","FTHR","FTI","FTO","FUEL","FUJIY","FUL",
"FULT","FUN","FUNC","FUR","FVE","FWFC","FWHT","FWLRF","FWRD","FWV","FXEN","G",
"GABC","GAFC","GAI","GAIA","GAIT","GAP","GAS","GB","GBBK","GBCI","GBCIP","GBI",
"GBL","GBN","GBND","GBP","GBR","GBTB","GBTS","GBTVK","GBX","GCBC","GCBS","GCFB",
"GCFC","GCI","GCO","GCOM","GCOR","GD","GDI","GDP","GDT","GDW","GDYS","GE",
"GEB","GEF","GEG","GEHL","GEL","GEMP","GEMS","GENR","GENZ","GEOI","GEPT","GERN",
"GES","GET","GEXA","GFED","GFF","GFI","GFLS","GFR","GFX","GG","GGAL","GGB",
"GGC","GGG","GGI","GGNS","GGP","GGR","GGY","GHCI","GHM","GI","GIB","GIFI",
"GIGA","GIGM","GIII","GIL","GILD","GILTF","GIS","GISX","GIVN","GIW","GKK","GKSR",
"GLAD","GLB","GLBCE","GLBL","GLBZ","GLDB","GLDC","GLDN","GLFD","GLG","GLGC","GLGS",
"GLH","GLK","GLNG","GLOV","GLOW","GLT","GLW","GLYT","GM","GMAI","GMCR","GME",
"GMK","GML","GMP","GMR","GMRK","GMST","GMT","GMTC","GMXR","GNBT","GNCMA","GNI",
"GNLB","GNRL","GNSC","GNSS","GNSY","GNTA","GNTX","GNTY","GNVC","GNW","GOJO","GOL",
"GOLD","GOOD","GOOG","GORX","GOSHA","GOT","GOV","GP","GPC","GPI","GPIC","GPK",
"GPN","GPP","GPRO","GPS","GPT","GPTX","GPX","GR","GRA","GRAN","GRB","GRC",
"GREY","GRI","GRIC","GRILE","GRMN","GRN","GROW","GRP","GRS","GRT","GRZ","GS",
"GSBC","GSF","GSH","GSIC","GSK","GSL","GSLI","GSOL","GSS","GT","GTA","GTCB",
"GTI","GTIM","GTIV","GTK","GTM","GTN","GTNA","GTOP","GTRC","GTSI","GTW","GTY",
"GV","GVA","GVBK","GVHR","GVP","GW","GWR","GWW","GXP","GXY","GY","GYI",
"GYMB","GYRO","HA","HABC","HAE","HAFC","HAFEC","HAIN","HAL","HAMP","HAN","HANA",
"HANS","HAR","HARB","HARL","HAS","HAST","HAUP","HAWK","HAXS","HAYZ","HB","HBAN",
"HBC","HBG","HBHC","HBIO","HBNC","HBP","HBY","HC","HCA","HCBK","HCC","HCH",
"HCM","HCN","HCP","HCR","HCSG","HCT","HCTL","HD","HDB","HDI","HDII","HDL",
"HDNG","HDSN","HDTV","HDWR","HE","HEB","HEC","HED","HEI","HEIA","HEII","HELX",
"HEOP","HEPH","HET","HETC","HEW","HFBC","HFFC","HFIT","HFWA","HGGR","HGIC","HGR",
"HGSI","HGT","HH","HHGP","HHS","HIB","HIBB","HIFN","HIFS","HIG","HIH","HIHO",
"HILL","HIT","HITK","HIW","HKF","HL","HLD","HLEX","HLFC","HLIT","HLR","HLT",
"HLTH","HLYW","HMA","HMB","HMC","HME","HMGN","HMN","HMNF","HMSY","HMT","HMX",
"HMY","HNBC","HNI","HNP","HNR","HNT","HNV","HNZ","HOFF","HOFT","HOLL","HOLX",
"HOM","HOMF","HOMS","HOMZ","HON","HOO","HOOK","HORC","HORT","HOST","HOT","HOV",
"HP","HPC","HPOL","HPQ","HPT","HR","HRB","HRBT","HRH","HRL","HRLY","HRP",
"HRS","HRSH","HRT","HRVE","HRZB","HSC","HSIC","HSII","HSKA","HSP","HSR","HSTM",
"HSVLY","HSY","HT","HTBK","HTC","HTCH","HTCO","HTEK","HTG","HTL","HTLD","HTLF",
"HTM","HTRN","HTV","HU","HUBA","HUBG","HUG","HUGO","HUM","HUMC","HUMP","HURC",
"HVT","HVTA","HWEN","HWFG","HWG","HWK","HWKN","HX","HXL","HYC","HYDL","HYGS",
"HYPR","HYSL","HZO","IAAC","IAAI","IACI","IAG","IAIA","IAL","IAO","IART","IASG",
"IAX","IBA","IBCA","IBCP","IBIS","IBKC","IBM","IBN","IBNK","IBOC","IBPI","ICA",
"ICAB","ICAD","ICBC","ICCA","ICCC","ICCI","ICH","ICI","ICLR","ICOC","ICOR","ICOS",
"ICPT","ICST","ICTG","ICTS","ICU","ICUI","IDA","IDBE","IDC","IDCC","IDEV","IDGR",
"IDN","IDNX","IDR","IDSA","IDSY","IDT","IDTC","IDTI","IDXC","IDXX","IED","IEIB",
"IES","IEX","IFC","IFCB","IFCJ","IFCN","IFF","IFIN","IFLO","IFNY","IFOX","IFS",
"IFSB","IFSIA","IFX","IG","IGC","IGI","IGL","IGLD","IGT","IGTE","IHC","IHG",
"IHI","IHP","IHR","IHT","IIG","IIIN","IINT","IIP","IIT","IIVI","IJX","IKN",
"IKNX","ILA","ILC","ILE","ILMN","ILOG","ILSE","ILX","ILXO","IM","IMA","IMAX",
"IMCL","IMCO","IMDC","IME","IMGC","IMGN","IMH","IMI","IMKTA","IMM","IMMR","IMMU",
"IMN","IMNR","IMNY","IMO","IMOS","IMR","IMX","IMY","IN","INB","INCY","INDB",
"INET","INEY","INFA","INFO","INFS","INFT","INFY","ING","INGN","INGP","INGR","INHX",
"ININ","INKP","INLD","INMD","INMT","INNO","INOC","INOD","INOW","INPH","INS","INSG",
"INSM","INSP","INSU","INSW","INT","INTC","INTD","INTL","INTN","INTT","INTU","INTV",
"INTZ","INVN","INVX","IO","IOC","IOM","ION","IONA","IONN","IOT","IOTN","IOX",
"IP","IPA","IPAR","IPAS","IPCC","IPCR","IPG","IPI","IPIX","IPMT","IPR","IPS",
"IPSU","IPT","IPXL","IQW","IR","IRC","IRE","IREP","IRETS","IRF","IRGI","IRIS",
"IRIX","IRM","IRN","IRS","IRSN","IRW","ISCA","ISG","ISH","ISIG","ISIL","ISIS",
"ISLE","ISNS","ISO","ISON","ISPH","ISR","ISRG","ISRL","ISSC","ISSI","ISSX","IST",
"ISTA","ISV","ISWI","ISYS","ITCD","ITG","ITIC","ITIGE","ITLA","ITMN","ITP","ITRA",
"ITRI","ITRSA","ITT","ITU","ITW","ITY","IUSA","IVAC","IVAN","IVC","IVD","IVGN",
"IVII","IVIL","IVIS","IVTA","IVX","IW","IWOV","IX","JACO","JADE","JAH","JAKK",
"JAMS","JAS","JAX","JAXB","JBHT","JBL","JBLU","JBOH","JBSS","JBX","JCC","JCDA",
"JCI","JCOM","JCP","JCS","JDAS","JDSU","JEC","JEF","JEN","JFBC","JFBI","JH",
"JHX","JILL","JJSF","JJZ","JKHY","JLG","JLL","JLMC","JLN","JMAR","JMBI","JNC",
"JNJ","JNPR","JNS","JNY","JOB","JOBS","JOE","JOSB","JOUT","JOYG","JP","JPM",
"JQH","JRC","JRN","JST","JTX","JUNO","JUPM","JWB","JWL","JWN","K","KAI",
"KAMNA","KANA","KB","KBALB","KBH","KCI","KCLI","KCP","KCS","KDE","KDN","KEA",
"KEG","KEI","KELYA","KELYB","KEM","KENT","KEP","KEQU","KERX","KEX","KEY","KEYN",
"KEYS","KEYW","KFRC","KFS","KFT","KFX","KFY","KG","KGC","KHK","KILN","KIM",
"KIND","KIRK","KKD","KLAC","KLIC","KMB","KMG","KMGB","KMI","KML","KMP","KMR",
"KMRT","KMT","KMX","KNAP","KNBT","KNBWY","KNDL","KNGT","KNM","KNOL","KNSY","KNTA",
"KO","KOF","KOMG","KOOL","KOPN","KOR","KOSN","KOSP","KOSS","KPA","KPN","KPP",
"KR","KRB","KRC","KRG","KRI","KRO","KRON","KRT","KRY","KSE","KSL","KSP",
"KSS","KSU","KSWS","KT","KTC","KTCC","KTEC","KTII","KTO","KUB","KVB","KVHI",
"KWD","KWIC","KWK","KWR","KYO","KYPH","KZL","L","LAB","LABL","LABS","LACO",
"LAD","LAF","LAKE","LAMR","LANC","LANV","LARL","LAUR","LAVA","LAWS","LAYN","LB",
"LBAI","LBIX","LBTYA","LBTYB","LBY","LC","LCAV","LCBM","LCCI","LCI","LCRD","LCRY",
"LCUT","LDG","LDL","LDR","LDSH","LEA","LECO","LEE","LEG","LEH","LEIX","LEN",
"LEND","LENS","LEON","LEV","LEXG","LEXR","LF","LFB","LFC","LFG","LFL","LFP",
"LFTC","LFUS","LG","LGF","LGL","LGN","LGND","LGTY","LGVN","LH","LHMS","LHO",
"LIC","LICB","LIFC","LIFE","LIHRY","LII","LIN","LINK","LION","LIOX","LIPD","LIZ",
"LJPC","LKFN","LKI","LKQX","LLL","LLTC","LLY","LM","LMCB","LMIA","LMLP","LMNX",
"LMS","LMT","LNBB","LNC","LNCB","LNCE","LNCR","LNDC","LNET","LNG","LNN","LNOP",
"LNR","LNT","LNUX","LNY","LODG","LOGC","LOGI","LOJN","LOOK","LOW","LPHI","LPL",
"LPMA","LPNT","LPSN","LPTH","LPX","LQ","LQI","LQU","LR","LRCX","LRNS","LRP",
"LRT","LRW","LRY","LSBC","LSBX","LSCC","LSCO","LSCP","LSE","LSI","LSS","LSTR",
"LTBG","LTC","LTD","LTM","LTON","LTR","LTRE","LTRX","LTS","LTXX","LU","LUB",
"LUCY","LUFK","LUK","LUM","LUV","LUX","LVB","LVLT","LWAY","LWSN","LXBK","LXK",
"LXP","LXU","LYG","LYNX","LYO","LYTS","LZ","LZB","MAA","MAC","MACE","MACR",
"MAD","MAFB","MAG","MAGS","MAHI","MAIN","MAIR","MAJR","MALL","MAM","MAMA","MAN",
"MANA","MANC","MANH","MANT","MANU","MAPS","MAPX","MAR","MARPS","MARSA","MARSB","MAS",
"MASB","MAT","MATK","MATR","MATW","MAX","MAXC","MAXE","MAXF","MAXM","MAXY","MAY",
"MBAY","MBFI","MBG","MBHI","MBI","MBLA","MBP","MBRG","MBRS","MBRX","MBT","MBTF",
"MBVA","MBVT","MBWM","MC","MCBC","MCBF","MCC","MCCC","MCD","MCDT","MCDTA","MCEL",
"MCF","MCGC","MCH","MCHM","MCHP","MCIP","MCK","MCLD","MCM","MCO","MCRI","MCRL",
"MCRS","MCS","MCTI","MCU","MCX","MCY","MCZ","MDC","MDCA","MDCC","MDCI","MDCO",
"MDG","MDII","MDKI","MDLK","MDP","MDR","MDRX","MDS","MDSI","MDST","MDT","MDTH",
"MDTL","MDU","MDWV","MDZ","MEAD","MECA","MED","MEDC","MEDI","MEDW","MEDX","MEE",
"MEG","MEH","MEL","MEM","MENT","MEOH","MER","MERB","MERCS","MERQ","MERX","MESA",
"MET","METG","METH","MFA","MFBC","MFC","MFCO","MFE","MFI","MFLO","MFLR","MFLX",
"MFN","MFRI","MFSF","MFW","MGA","MGAM","MGEE","MGG","MGI","MGIC","MGLN","MGM",
"MGN","MGP","MGPI","MGRC","MGS","MHC","MHCA","MHG","MHK","MHL","MHM","MHO",
"MHP","MHR","MHS","MHX","MI","MICC","MICU","MIDD","MIG","MIGP","MII","MIK",
"MIKN","MIKR","MIL","MIM","MIMS","MIND","MINI","MIPS","MITSY","MITY","MKC","MKCV",
"MKL","MKSI","MKT","MKTAY","MKTW","MKTY","MLAB","MLAN","MLB","MLEA","MLHR","MLI",
"MLIN","MLM","MLNM","MLP","MLR","MLS","MMA","MMAN","MMC","MMLP","MMM","MMP",
"MNS","MNST","MNT","MNTA","MNTG","MO","MOBE","MOBI","MOCC","MOCO","MODI","MODT",
"MOGN","MOH","MOLX","MOLXA","MON","MOND","MONE","MONM","MOSS","MOSY","MOT","MOTV",
"MOV","MOVI","MPAC","MPE","MPET","MPG","MPP","MPQ","MPR","MPS","MPWG","MPX",
"MRAE","MRB","MRBK","MRCIY","MRCY","MRD","MRGE","MRH","MRIA","MRK","MRLN","MRM",
"MRN","MRO","MROE","MROI","MRSA","MRTI","MRTN","MRVC","MRVL","MRVT","MRX","MRY",
"MS","MSA","MSB","MSBK","MSC","MSCC","MSEL","MSEX","MSFG","MSFT","MSGI","MSHL",
"MSI","MSK","MSL","MSLV","MSM","MSN","MSO","MSON","MSPD","MSS","MSSN","MSTR",
"MSW","MTA","MTB","MTCH","MTCT","MTD","MTE","MTEK","MTEX","MTF","MTG","MTH",
"MTIC","MTIX","MTLG","MTLK","MTLM","MTMC","MTMD","MTN","MTOH","MTR","MTRX","MTSC",
"MTSL","MTSN","MTSX","MTW","MTX","MTXC","MTXX","MTY","MTZ","MU","MUEL","MUR",
"MUSA","MUSE","MVCO","MVIS","MVK","MVL","MVSN","MW","MWAV","MWD","MWE","MWP",
"MWRK","MWV","MWY","MX","MXBIF","MXICY","MXIM","MXM","MXO","MXRE","MXT","MXWL",
"MYE","MYG","MYGN","MYK","MYL","MYOG","MYR","MYS","MYST","MZ","MZT","N",
"NAB","NABI","NADX","NAFC","NAII","NANO","NANX","NAP","NARA","NASB","NASI","NAT",
"NATH","NATI","NATK","NATR","NAV","NAVG","NAVI","NAVR","NAX","NBAN","NBG","NBIX",
"NBL","NBN","NBP","NBR","NBSC","NBTB","NBTF","NBY","NC","NCC","NCEM","NCF",
"NCFC","NCI","NCOG","NCR","NCRI","NCRX","NCS","NCT","NCX","NDC","NDE","NDN",
"NDSN","NE","NEIB","NEM","NEN","NENG","NEOF","NEOG","NEOL","NEON","NEPF","NERX",
"NETC","NETE","NETM","NEU","NEWH","NEWP","NEXM","NFB","NFG","NFI","NFLD","NFLX",
"NFP","NFS","NFX","NG","NGA","NGAS","NGEN","NGG","NGPS","NGRU","NGS","NGT",
"NHC","NHHC","NHI","NHP","NHR","NHTB","NHY","NI","NICE","NICH","NICK","NIHD",
"NIKU","NILE","NIPNY","NIS","NITE","NJ","NJR","NKBS","NKE","NKSH","NKTR","NL",
"NLCI","NLS","NLX","NLY","NMGB","NMGC","NMHC","NMIL","NMR","NMRX","NMSS","NMTI",
"NNBR","NNDS","NNI","NNN","NNPP","NOBH","NOBL","NOC","NOI","NOIZ","NOK","NOLD",
"NOOF","NOVA","NOVB","NOVL","NOVN","NOVT","NPBC","NPK","NPO","NPSI","NPSN","NPSP",
"NPTH","NR","NRCI","NRD","NRG","NRGN","NRGY","NRIM","NRMX","NRP","NRRD","NRT",
"NRVN","NSANY","NSATF","NSC","NSDA","NSDB","NSEC","NSFC","NSH","NSI","NSIT","NSK",
"NSM","NSO","NSS","NSSC","NST","NSTK","NSYS","NT","NTAP","NTBK","NTCT","NTE",
"NTEC","NTES","NTG","NTGR","NTI","NTII","NTIQ","NTL","NTLI","NTMD","NTN","NTO",
"NTOL","NTOP","NTPAE","NTR","NTRS","NTRT","NTSC","NTSL","NTST","NTT","NTWK","NTY",
"NTZ","NU","NUAN","NUCO","NUE","NUHC","NUI","NURM","NURO","NUS","NUT","NUTR",
"NVAL","NVAX","NVDA","NVDC","NVEC","NVGN","NVH","NVI","NVLD","NVLS","NVMI","NVO",
"NVR","NVS","NVTL","NWAC","NWD","NWFI","NWFL","NWIR","NWK","NWL","NWLIA","NWN",
"NWPX","NWRE","NWS","NWSB","NX","NXG","NXL","NXST","NXTL","NXTP","NXXI","NXY",
"NYB","NYER","NYM","NYMX","NYNY","NYT","NZT","NZYM","O","OAKF","OATS","OBAS",
"OBCI","OBIE","OBTLY","OCA","OCAS","OCCF","OCENY","OCFC","OCLR","OCN","OCNB","OCPI",
"OCR","ODC","ODFL","ODP","ODSY","OEH","OFC","OFG","OFI","OFIX","OGE","OHB",
"OHI","OI","OICO","OII","OIIM","OIS","OKE","OKSB","OLAB","OLBK","OLCB","OLG",
"OLGC","OLGR","OLN","OLP","OLY","OMC","OMCL","OME","OMEF","OMG","OMI","OMM",
"OMN","OMNI","OMR","OMTL","ONB","ONCY","ONFC","ONI","ONNN","ONT","ONVI","ONXS",
"ONXX","ONYX","OO","OOM","OPEN","OPHC","OPLK","OPMR","OPNT","OPOF","OPSW","OPT",
"OPTC","OPTN","OPTV","OPWV","OPY","ORB","ORBK","ORBT","ORBZ","ORCC","ORCI","ORCL",
"ORCT","ORFR","ORH","ORI","ORLY","ORPH","ORTN","OS","OSBC","OSCI","OSG","OSI",
"OSIP","OSIS","OSK","OSKY","OSTE","OSTK","OSUR","OTD","OTE","OTEX","OTIV","OTL",
"OTTR","OUTDD","OUTL","OVBC","OVNT","OVRL","OVTI","OWENQ","OXGN","OXM","OXY","OYOG",
"OZN","OZRK","PAA","PAAS","PAB","PACR","PACT","PACW","PAE","PAGI","PAL","PAM",
"PANL","PARL","PARS","PAS","PATK","PATR","PAX","PAYX","PBCI","PBCP","PBCT","PBG",
"PBI","PBIO","PBIZ","PBKS","PBNC","PBR","PBT","PBTC","PBY","PCAR","PCBC","PCBI",
"PCBK","PCC","PCCC","PCG","PCH","PCIS","PCL","PCLE","PCLN","PCMC","PCNTF","PCO",
"PCP","PCR","PCTI","PCTY","PCU","PCW","PCYC","PCYO","PCZ","PD","PDA","PDC",
"PDCO","PDE","PDEX","PDFS","PDG","PDII","PDLB","PDLI","PDQ","PDS","PDSG","PDX",
"PDYN","PEAK","PEBK","PEBO","PECS","PEET","PEG","PEGA","PEGS","PEI","PENN","PENX",
"PEP","PER","PERFE","PERY","PESI","PETC","PETD","PETM","PETS","PFB","PFBI","PFBX",
"PFCB","PFCO","PFDC","PFE","PFG","PFGC","PFI","PFIN","PFP","PFS","PFSB","PFSL",
"PFSW","PFT","PG","PGC","PGE","PGH","PGL","PGLAF","PGN","PGNX","PGR","PGTV",
"PH","PHC","PHCC","PHEL","PHELK","PHG","PHHM","PHI","PHLI","PHLY","PHM","PHMD",
"PHRM","PHS","PHSB","PHTN","PHX","PICO","PII","PIII","PIK","PILL","PIO","PIR",
"PIXR","PJC","PKBK","PKD","PKDY","PKE","PKG","PKI","PKOH","PKS","PKSI","PKTR",
"PKX","PKY","PKZ","PL","PLA","PLAA","PLAB","PLB","PLC","PLCC","PLCE","PLCM",
"PLD","PLE","PLFE","PLL","PLLL","PLMD","PLMO","PLNR","PLP","PLPC","PLRB","PLRE",
"PLT","PLUG","PLUM","PLUS","PLXS","PLXT","PMACA","PMBC","PMCS","PMD","PMED","PMFG",
"PMI","PMID","PMRY","PMSI","PMTC","PMTI","PMTR","PMU","PNB","PNBC","PNBK","PNC",
"PNCL","PNFP","PNG","PNK","PNM","PNN","PNNA","PNNW","PNO","PNP","PNR","PNRA",
"PNRG","PNS","PNTE","PNW","PNX","PNY","POCC","POCI","POG","POIX","POL","POLX",
"POM","PONR","POOL","POP","POPEZ","POS","POSO","POSS","POT","POTP","POWI","POWL",
"POZN","PP","PPBI","PPC","PPCO","PPD","PPDI","PPG","PPHM","PPK","PPL","PPP",
"PPS","PPTV","PPX","PQE","PQUE","PR","PRA","PRAA","PRAN","PRCP","PRCS","PRE",
"PREM","PRFS","PRFT","PRG","PRGO","PRGS","PRGX","PRK","PRKR","PRL","PRLS","PRLX",
"PRM","PROG","PROV","PROX","PRPX","PRRR","PRSC","PRSF","PRSP","PRST","PRSW","PRTL",
"PRU","PRV","PRVD","PRVT","PRW","PRWT","PRX","PRXL","PRZ","PSA","PSAA","PSAI",
"PSB","PSBI","PSD","PSEM","PSFT","PSIT","PSMT","PSO","PSRC","PSS","PSSI","PSTA",
"PSUN","PSYS","PT","PTA","PTC","PTEC","PTEK","PTEN","PTG","PTIE","PTIX","PTMK",
"PTN","PTNR","PTNX","PTON","PTP","PTR","PTRY","PTSI","PTSX","PTT","PTV","PTZ",
"PUB","PUK","PULB","PUMP","PURW","PV","PVA","PVD","PVFC","PVH","PVLS","PVN",
"PVR","PVSA","PVSW","PVTB","PVX","PW","PWAV","PWEI","PWER","PWI","PWN","PWOD",
"PWR","PWX","PX","PXD","PXG","PXLW","PXP","PXR","PXT","PYR","PYX","PZA",
"PZE","PZZA","PZZI","Q","QADI","QBAK","QCOM","QCRH","QDEL","QDIN","QEPC","QFAB",
"QGENF","QGLY","QLGC","QLTI","QLTY","QMED","QMM","QNTA","QRSI","QSC","QSFT","QSII",
"QSND","QTWW","QUIK","QUIN","QUIP","QUIX","QUOT","R","RA","RAD","RADA","RADI",
"RADN","RADS","RAE","RAGS","RAH","RAI","RAND","RANGY","RANKY","RARE","RAS","RATE",
"RAVN","RAY","RBA","RBAK","RBC","RBCAA","RBIN","RBK","RBN","RBNC","RBNF","RBPA",
"RBY","RC","RCCC","RCF","RCG","RCI","RCII","RCKY","RCL","RCMT","RCN","RCO",
"RCOM","RCRC","RD","RDA","RDC","RDCM","RDEN","RDI","RDK","RDN","RDTA","RDVW",
"RDWR","RDY","RE","REAL","REBC","RECN","REDE","REDF","REFR","REG","REGN","RELL",
"RELM","RELV","REM","REMC","REMX","RENT","REP","RES","RESC","RESP","RETK","REV",
"REVU","REXI","REXL","REXMY","REY","RF","RFIL","RFMD","RFMI","RG","RGA","RGC",
"RGCI","RGCO","RGEN","RGF","RGLD","RGR","RGS","RGX","RHA","RHAT","RHB","RHD",
"RHI","RI","RIC","RICK","RIG","RIGL","RIGS","RIMG","RIMM","RIN","RIO","RITA",
"RITT","RIV","RIVR","RJET","RJF","RKE","RKT","RKY","RL","RLI","RLRN","RMBS",
"RMCF","RMD","RMI","RMIX","RMK","RMKR","RML","RMTI","RMTR","RNAI","RNDC","RNHD",
"RNO","RNR","RNT","RNTA","RNVS","RNWK","ROAC","ROBO","ROCK","ROCM","ROFO","ROG",
"ROH","ROIA","ROIAK","ROK","ROL","ROME","RONC","ROP","ROS","ROST","ROV","ROW",
"ROXI","ROYL","RPFG","RPI","RPM","RPT","RRA","RRC","RRD","RRGB","RRI","RS",
"RSA","RSAS","RSC","RSCR","RSE","RSG","RSH","RST","RSTI","RSTO","RSYS","RT",
"RTC","RTEC","RTI","RTIX","RTK","RTLX","RTN","RTP","RTRSY","RTSX","RTWI","RUBO",
"RUK","RUN","RUS","RUSHA","RUSHB","RVI","RVP","RVSB","RVSN","RWT","RWY","RX",
"RY","RYAAY","RYAN","RYG","RYL","RYN","S","SA","SAB","SABA","SAFC","SAFM",
"SAFT","SAH","SAL","SALM","SAM","SAN","SANM","SANYY","SAP","SAPE","SASR","SAT",
"SATC","SAVB","SAY","SBAC","SBB","SBC","SBCF","SBEI","SBGA","SBGI","SBIB","SBIT",
"SBKC","SBL","SBLK","SBP","SBR","SBS","SBSA","SBSE","SBSI","SBTV","SBUX","SBYN",
"SC","SCB","SCBT","SCBV","SCG","SCH","SCHL","SCHN","SCHS","SCI","SCIL","SCIX",
"SCKT","SCL","SCLD","SCLN","SCM","SCMF","SCMM","SCMR","SCNYA","SCNYB","SCO","SCON",
"SCOX","SCRB","SCS","SCSC","SCSS","SCST","SCT","SCUR","SCVL","SCX","SCY","SDA",
"SDAY","SDIX","SDS","SDX","SE","SEAC","SEB","SEBL","SEE","SEGU","SEH","SEIC",
"SELA","SEM","SEMI","SEN","SEO","SEPR","SERO","SF","SFA","SFBC","SFCC","SFD",
"SFE","SFF","SFFS","SFG","SFI","SFL","SFLK","SFN","SFNC","SFNT","SFO","SFP",
"SFSW","SFY","SGA","SGB","SGC","SGDE","SGEN","SGG","SGHL","SGI","SGK","SGMA",
"SGMO","SGMS","SGP","SGR","SGRP","SGTL","SGU","SGY","SHBI","SHBK","SHD","SHEN",
"SHF","SHFL","SHG","SHI","SHLM","SHLO","SHOE","SHOO","SHPGY","SHR","SHRP","SHS",
"SHU","SHW","SI","SIAL","SID","SIE","SIEB","SIF","SIFY","SIGA","SIGI","SIGM",
"SIGY","SII","SIL","SILCF","SILI","SIM","SIMC","SIMG","SINA","SINT","SIPX","SIR",
"SIRI","SISI","SIVB","SIZ","SJH","SJI","SJM","SJOE","SJR","SJT","SJW","SKE",
"SKFB","SKIL","SKM","SKO","SKP","SKS","SKT","SKX","SKY","SKYE","SKYF","SKYW",
"SLAB","SLB","SLE","SLF","SLFI","SLG","SLGN","SLH","SLI","SLM","SLNK","SLP",
"SLR","SLS","SLTC","SLXP","SM","SMAN","SMBC","SMBI","SMD","SMDI","SMF","SMG",
"SMHG","SMI","SMIT","SMMX","SMP","SMRA","SMRT","SMSC","SMSI","SMT","SMTC","SMTI",
"SMTL","SMTR","SMTS","SMVA","SMXC","SNA","SNAK","SNBC","SNBT","SNCI","SNDA","SNDK",
"SNDS","SNDT","SNE","SNFCA","SNG","SNH","SNHY","SNIC","SNMX","SNN","SNP","SNPS",
"SNR","SNRR","SNS","SNSA","SNT","SNTK","SNTO","SNUS","SNV","SNWL","SNX","SNY",
"SO","SOCB","SOFO","SOHU","SOL","SOMH","SON","SONC","SONE","SONO","SONT","SORC",
"SOS","SOSA","SOTR","SOV","SP","SPA","SPAB","SPAN","SPAR","SPCH","SPDE","SPEC",
"SPEX","SPF","SPG","SPH","SPI","SPIL","SPIR","SPLN","SPLS","SPM","SPN","SPNC",
"SPNS","SPOR","SPP","SPPI","SPRI","SPRT","SPRX","SPTN","SPW","SQAB","SQM","SQNM",
"SR","SRA","SRCE","SRCL","SRCP","SRDX","SRE","SRG","SRI","SRLS","SRNA","SRP",
"SRR","SRSL","SRT","SRTI","SRX","SRXA","SRZ","SSCC","SSD","SSE","SSFC","SSFT",
"SSI","SSL","SSNC","SSP","SSPI","SSRI","SSRV","SSS","SSTI","SSTR","SSY","SSYS",
"STA","STAA","STAN","STAR","STB","STBA","STBI","STC","STCR","STD","STE","STEC",
"STEI","STEL","STEM","STEN","STFC","STG","STGN","STGS","STHK","STHLY","STI","STIZ",
"STJ","STK","STKL","STKR","STL","STLD","STLW","STLY","STM","STMP","STN","STNJ",
"STNR","STO","STOSY","STR","STRA","STRC","STRD","STRS","STRT","STRZ","STS","STSA",
"STSI","STST","STT","STTS","STTX","STU","STV","STW","STX","STXN","STXS","STZ",
"STZB","SU","SUBI","SUBK","SUG","SUI","SUMM","SUMT","SUMX","SUN","SUNH","SUNN",
"SUNW","SUP","SUPC","SUPG","SUPVA","SUPX","SUR","SURW","SUSQ","SVBF","SVBI","SVC",
"SVCW","SVIN","SVM","SVNT","SVNX","SVU","SVVS","SWB","SWBT","SWC","SWFT","SWHI",
"SWIR","SWK","SWKS","SWM","SWMAY","SWN","SWRG","SWS","SWW","SWWC","SWX","SWY",
"SXI","SXL","SXT","SY","SYBR","SYD","SYGR","SYI","SYK","SYKE","SYM","SYMC",
"SYMM","SYNA","SYNC","SYNF","SYNL","SYNM","SYNO","SYNP","SYNT","SYNX","SYPR","SYT",
"SYX","SYXI","SYY","SZ","SZE","SZI","T","TAC","TACT","TACX","TAG","TAGS",
"TAIT","TALK","TALX","TAR","TARO","TARR","TASR","TATTF","TAXI","TAYC","TAYD","TBAC",
"TBC","TBCC","TBE","TBH","TBIO","TBL","TBNC","TBUS","TBWC","TCAM","TCB","TCBI",
"TCBK","TCC","TCCO","TCHC","TCI","TCLP","TCN","TCNO","TCO","TCP","TCR","TCT",
"TD","TDI","TDK","TDS","TDSC","TDW","TDY","TE","TEAM","TECD","TECH","TECU",
"TECUB","TEF","TEK","TEKC","TELK","TELN","TELOZ","TEM","TEN","TENT","TEO","TER",
"TERN","TESOF","TESS","TEU","TEVA","TEX","TFCO","TFF","TFIN","TFN","TFONY","TFR",
"TFS","TFX","TG","TGA","TGAL","TGB","TGC","TGEN","TGI","TGIC","TGN","TGS",
"TGT","TGX","THC","THFF","THO","THOR","THQI","THRD","THRX","THT","THV","THX",
"TI","TIA","TIBB","TIBX","TICC","TIE","TIER","TIF","TII","TIII","TIK","TIN",
"TINY","TISA","TIV","TIVO","TIWI","TJX","TK","TKA","TKC","TKCI","TKG","TKLC",
"TKO","TKP","TKR","TKS","TKTX","TLAB","TLB","TLCV","TLCX","TLD","TLF","TLGB",
"TLGD","TLK","TLL","TLM","TLS","TLTOB","TLWT","TLX","TM","TMA","TMAR","TMB",
"TMG","TMI","TMIC","TMK","TMM","TMNG","TMO","TMP","TMR","TMS","TMTA","TMWD",
"TMX","TNB","TNC","TNE","TNH","TNL","TNM","TNOX","TNP","TNS","TNT","TO",
"TOC","TOD","TOF","TOFC","TOL","TOM","TOMO","TONE","TONS","TOO","TOPP","TORC",
"TORM","TOT","TOUS","TOX","TOY","TP","TPC","TPE","TPGI","TPL","TPP","TPPH",
"TPPP","TPR","TPTH","TPTI","TPX","TPY","TQ","TQNT","TR","TRA","TRAC","TRAD",
"TRB","TRBO","TRBS","TRC","TRCA","TRCI","TRCR","TRDO","TRFDF","TRFX","TRGL","TRGN",
"TRH","TRI","TRIB","TRID","TRK","TRKN","TRLY","TRMB","TRMD","TRMK","TRMM","TRMS",
"TRN","TRNI","TRNS","TRO","TROW","TRP","TRPH","TRPS","TRR","TRST","TRT","TRU",
"TRVS","TRY","TRZ","TS","TSA","TSAI","TSBK","TSC","TSCC","TSCM","TSCO","TSD",
"TSEM","TSFG","TSG","TSH","TSIC","TSM","TSMA","TSN","TSO","TSP","TSRA","TSRI",
"TSS","TSTF","TSU","TSYS","TT","TTC","TTEC","TTEK","TTES","TTG","TTI","TTIL",
"TTMI","TTN","TTP","TTPA","TTWO","TU","TUC","TUES","TUG","TUNE","TUP","TUTR",
"TUTS","TV","TVIA","TVIN","TVL","TW","TWAV","TWI","TWMC","TWP","TWR","TWTC",
"TWTI","TWTR","TWW","TWX","TXCC","TXCO","TXI","TXN","TXT","TXU","TXUI","TYC",
"TYL","TZA","TZIX","TZOO","UAG","UAHC","UAIRQ","UALAQ","UB","UBA","UBB","UBCD",
"UBCP","UBET","UBFO","UBH","UBMT","UBOH","UBP","UBS","UBSH","UBSI","UCBH","UCBI",
"UCFC","UCI","UCL","UCO","UCOMA","UDI","UDR","UDW","UEIC","UFBS","UFCS","UFI",
"UFM","UFPI","UFPT","UG","UGI","UGP","UHAL","UHCO","UHCP","UHS","UHT","UIC",
"UIL","UIS","UL","ULBI","ULCM","ULGX","ULTE","ULTI","UMBF","UMC","UMH","UMPQ",
"UN","UNA","UNAM","UNB","UNEWY","UNF","UNFI","UNGL","UNH","UNIB","UNIZ","UNM",
"UNP","UNS","UNT","UNTD","UNTY","UNWR","UPCS","UPL","UPM","UPS","UQM","URBN",
"URGI","URI","URS","URT","USAK","USAP","USB","USBI","USEG","USEY","USFC","USG",
"USHS","USIH","USLM","USM","USNA","USPH","USPI","UST","USTR","USU","USV","UTEK",
"UTHR","UTI","UTIW","UTK","UTL","UTMD","UTR","UTSI","UTX","UU","UUU","UVN",
"UVSL","UVSP","UVV","UWN","V","VAIL","VAL","VALU","VAR","VARI","VAS","VASC",
"VASO","VAST","VATA","VC","VCBI","VCI","VCLK","VCMP","VCO","VCP","VDAT","VDM",
"VDSI","VE","VECO","VELCF","VENP","VERT","VEXP","VFC","VFGI","VFLX","VGR","VGZ",
"VHI","VIA","VICL","VICR","VIDE","VIFL","VIGN","VII","VION","VIP","VIR","VIRL",
"VISG","VITA","VITL","VITR","VITX","VIVO","VLCCF","VLFG","VLG","VLGC","VLGEA","VLI",
"VLNC","VLO","VLTS","VLY","VMC","VMI","VMSI","VMTI","VNBC","VNLS","VNO","VNT",
"VNWI","VNWK","VNX","VOCL","VOD","VOL","VOLVY","VOXX","VPF","VPHM","VPI","VPS",
"VRA","VRC","VRLK","VRNT","VRSN","VRSO","VRST","VRTX","VRTY","VRX","VRYA","VSAT",
"VSCI","VSEA","VSEC","VSF","VSGN","VSH","VSL","VSNT","VSR","VSTA","VSTY","VTA",
"VTAL","VTEK","VTIV","VTO","VTR","VTS","VTSS","VUL","VVC","VVI","VVN","VVTV",
"VVUS","VWKS","VWPT","VYYO","VZ","WAB","WABC","WACLY","WAG","WAIN","WASH","WAT",
"WATFZ","WAVX","WAYN","WB","WBCO","WBD","WBK","WBKC","WBNK","WBR","WBS","WBSN",
"WC","WCAP","WCBO","WCC","WCFB","WCI","WCN","WDC","WDFC","WDHD","WDR","WEB",
"WEBM","WEBX","WEC","WEDC","WEDX","WEFC","WEFN","WEH","WEL","WEN","WERN","WES",
"WEX","WEYS","WF","WFC","WFD","WFI","WFIIE","WFMI","WFR","WFSI","WFSL","WFT",
"WG","WGA","WGAT","WGBC","WGII","WGL","WGNB","WGNR","WGO","WGOV","WGR","WGRD",
"WHG","WHI","WHQ","WHR","WHRT","WHT","WHX","WIBC","WILCF","WIN","WINA","WIND",
"WINS","WIRE","WIT","WITM","WITS","WJCI","WL","WLB","WLC","WLDA","WLFC","WLL",
"WLM","WLP","WLS","WLSN","WLT","WLV","WM","WMAR","WMB","WMC","WMGI","WMI",
"WMK","WMS","WMSI","WMT","WNC","WNI","WNNB","WOC","WOLV","WON","WOOF","WOR",
"WOS","WPC","WPI","WPL","WPO","WPP","WPPGY","WPS","WPSC","WQNI","WR","WRE",
"WRI","WRLD","WRLS","WRNC","WRO","WRP","WRS","WSB","WSBA","WSBC","WSBI","WSC",
"WSCC","WSCI","WSFS","WSH","WSII","WSM","WSO","WST","WSTC","WSTF","WSTL","WSTM",
"WTBA","WTFC","WTM","WTNY","WTR","WTRS","WTS","WTSLA","WTT","WTU","WTW","WTZ",
"WVCM","WVFC","WVVI","WW","WWCA","WWE","WWIN","WWW","WWY","WXH","WY","WYE",
"WYNN","WYPT","WZEN","X","XATA","XCYT","XEC","XEDA","XEL","XETA","XIDE","XING",
"XJT","XL","XLA","XLNX","XLTC","XMSR","XNR","XNVA","XOCM","XOM","XOMA","XPRS",
"XPRT","XRAY","XRIT","XRTX","XRX","XTEX","XTND","XTO","XTXI","XXIA","XYBR","Y",
"YAKC","YANB","YAVY","YBTVA","YCC","YDIW","YDNT","YELL","YHOO","YMI","YOCM","YORW",
"YPF","YRK","YUM","YZC","ZANE","ZAP","ZBRA","ZCOM","ZEUS","ZGEN","ZHNE","ZICA",
};

////////////////////////////////////////////////////////////////////////////
// CESignalTestDlg dialog

CESignalTestDlg::CESignalTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CESignalTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CESignalTestDlg)
	m_lblElapsed = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_nSymIndex	= 0;
	m_tStart	= CTime::GetCurrentTime();
	m_tStop		= CTime::GetCurrentTime();
	m_bRunning	= FALSE;
}

void CESignalTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CESignalTestDlg)
	DDX_Control(pDX, IDC_BUT_STOP_ALL, m_butStopAll);
	DDX_Control(pDX, IDC_BUT_STARTALL, m_butStartAll);
	DDX_Control(pDX, IDC_BUT_ESIGNAL,   m_butESignal1);
	DDX_Control(pDX, IDC_BUT_ESIGNAL2,  m_butESignal2);
	DDX_Control(pDX, IDC_BUT_ESIGNAL3,  m_butESignal3);
	DDX_Control(pDX, IDC_BUT_ESIGNAL4,  m_butESignal4);
	DDX_Control(pDX, IDC_BUT_ESIGNAL5,  m_butESignal5);
	DDX_Control(pDX, IDC_BUT_ESIGNAL6,  m_butESignal6);
	DDX_Control(pDX, IDC_BUT_ESIGNAL7,  m_butESignal7);
	DDX_Control(pDX, IDC_BUT_ESIGNAL8,  m_butESignal8);
	DDX_Control(pDX, IDC_BUT_ESIGNAL9,  m_butESignal9);
	DDX_Control(pDX, IDC_BUT_ESIGNAL10, m_butESignal10);
	DDX_Control(pDX, IDC_BUT_ESIGNAL11, m_butESignal11);
	DDX_Control(pDX, IDC_BUT_ESIGNAL12, m_butESignal12);
	DDX_Control(pDX, IDC_BUT_ESIGNAL13, m_butESignal13);
	DDX_Control(pDX, IDC_BUT_ESIGNAL14, m_butESignal14);
	DDX_Control(pDX, IDC_BUT_ESIGNAL15, m_butESignal15);
	DDX_Control(pDX, IDC_BUT_ESIGNAL16, m_butESignal16);
	DDX_Control(pDX, IDC_BUT_ESIGNAL17, m_butESignal17);
	DDX_Control(pDX, IDC_BUT_ESIGNAL18, m_butESignal18);
	DDX_Control(pDX, IDC_BUT_ESIGNAL19, m_butESignal19);
	DDX_Control(pDX, IDC_BUT_ESIGNAL20, m_butESignal20);
	DDX_Control(pDX, IDC_BUT_ESIGNAL21, m_butESignal21);
	DDX_Control(pDX, IDC_BUT_ESIGNAL22, m_butESignal22);
	DDX_Control(pDX, IDC_BUT_ESIGNAL23, m_butESignal23);
	DDX_Control(pDX, IDC_BUT_ESIGNAL24, m_butESignal24);
	DDX_Control(pDX, IDC_BUT_ESIGNAL25, m_butESignal25);
	DDX_Control(pDX, IDC_BUT_ESIGNAL26, m_butESignal26);
	DDX_Control(pDX, IDC_BUT_ESIGNAL27, m_butESignal27);
	DDX_Control(pDX, IDC_BUT_ESIGNAL28, m_butESignal28);
	DDX_Control(pDX, IDC_BUT_ESIGNAL29, m_butESignal29);
	DDX_Control(pDX, IDC_BUT_ESIGNAL30, m_butESignal30);
	DDX_Control(pDX, IDC_BUT_ESIGNAL31, m_butESignal31);
	DDX_Control(pDX, IDC_BUT_ESIGNAL32, m_butESignal32);
	DDX_Control(pDX, IDC_BUT_ESIGNAL33, m_butESignal33);
	DDX_Control(pDX, IDC_BUT_ESIGNAL34, m_butESignal34);
	DDX_Control(pDX, IDC_BUT_ESIGNAL35, m_butESignal35);
	DDX_Control(pDX, IDC_BUT_ESIGNAL36, m_butESignal36);
	DDX_Control(pDX, IDC_BUT_ESIGNAL37, m_butESignal37);
	DDX_Control(pDX, IDC_BUT_ESIGNAL38, m_butESignal38);
	DDX_Control(pDX, IDC_BUT_ESIGNAL39, m_butESignal39);
	DDX_Control(pDX, IDC_BUT_ESIGNAL40, m_butESignal40);
	DDX_Text(pDX, IDC_LBL_ELAPSED, m_lblElapsed);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CESignalTestDlg, CDialog)
	//{{AFX_MSG_MAP(CESignalTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUT_STARTALL, OnButStartAll)
	ON_BN_CLICKED(IDC_BUT_STOP_ALL, OnButStopAll)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CESignalTestDlg message handlers

BOOL CESignalTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	::SetTimer( GetSafeHwnd(), TF_TIMER_ID,  TF_TIMER_USEC, NULL);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CESignalTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CESignalTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CESignalTestDlg::OnButStartAll() 
{
	int				nStart		= IDC_BUT_ESIGNAL;
	int				nStop		= IDC_BUT_ESIGNAL40;
	int				i;
	CESigBut		*pBut;

	for( i = nStart; i <= nStop; i++ ) {

		pBut	= (CESigBut*)GetDlgItem(i);

		pBut->Start();
	}

	m_tStart	= CTime::GetCurrentTime();
	m_bRunning	= TRUE;
}

void CESignalTestDlg::OnButStopAll() 
{
	int				nStart		= IDC_BUT_ESIGNAL;
	int				nStop		= IDC_BUT_ESIGNAL40;
	int				i;
	CESigBut		*pBut;

	for( i = nStart; i <= nStop; i++ ) {

		pBut	= (CESigBut*)GetDlgItem(i);

		pBut->Stop();
	}

	m_tStop		= CTime::GetCurrentTime();
	m_bRunning	= FALSE;
}

void CESignalTestDlg::OnTimer(UINT nIDEvent) 
{
	int				nStart		= IDC_BUT_ESIGNAL;
	int				nStop		= IDC_BUT_ESIGNAL40;
	CString			strSym;
	CTime			tCurrent	= CTime::GetCurrentTime();
	CTimeSpan		tSpan;
	int				i;
	CESigBut		*pBut;

	for( i = nStart; i <= nStop; i++ ) {

		pBut	= (CESigBut*)GetDlgItem(i);

		strSym	= pSymbols[m_nSymIndex++];
		strSym.TrimRight();

		pBut->SetSymbol( strSym );

//		OutputDebugString(strSym + " ");

		if( m_nSymIndex > 980 ) {
			m_nSymIndex	= 0;
//			OutputDebugString("Sym Loop\n");
		} else if ( (m_nSymIndex % 20) == 0 ) {
//			OutputDebugString("\n");
		}
	}

	if( m_bRunning ) {
		tSpan		= tCurrent - m_tStart;

		m_lblElapsed.Format("Elapsed %d:%02d", tSpan.GetMinutes(), tSpan.GetSeconds() );
	} else {
		m_lblElapsed.Format("Stopped.");
	}


	UpdateData( FALSE );
}
