// EventSink.cpp : implementation file
//

#include "stdafx.h"
#include "EventSink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EventSink

IMPLEMENT_DYNCREATE(EventSink, CCmdTarget)

EventSink::EventSink()
{
   m_pListener = NULL;
	EnableAutomation();
}

EventSink::EventSink(EventSinkListener *pListener) 
{
	m_pListener = pListener;
	EnableAutomation();
}

EventSink::~EventSink()
{
}


void EventSink::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(EventSink, CCmdTarget)
	//{{AFX_MSG_MAP(EventSink)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(EventSink, CCmdTarget)
	//{{AFX_DISPATCH_MAP(EventSink)
	   DISP_FUNCTION_ID(EventSink, "OnSymbolChanged",			1,  OnSymbolChanged,			VT_ERROR, VTS_BSTR)
	   DISP_FUNCTION_ID(EventSink, "OnQuoteChanged",			2,  OnQuoteChanged,			VT_ERROR, VTS_BSTR)
      DISP_FUNCTION_ID(EventSink, "OnBarsChanged",			   3,  OnBarsChanged,			VT_ERROR, VTS_I4)
      DISP_FUNCTION_ID(EventSink, "OnBarsReceived",			4,  OnBarsReceived,			VT_ERROR, VTS_I4)
      DISP_FUNCTION_ID(EventSink, "OnPlaceOrder",				5,  OnPlaceOrder,			   VT_ERROR, VTS_BSTR)
      DISP_FUNCTION_ID(EventSink, "OnTimeSalesChanged",		12, OnTimeSalesChanged,		VT_ERROR, VTS_I4)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IEventSink to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {A7E17FDF-37B6-48F5-862C-3A5FA1CF7B26}
static const IID IID_IEventSink =
{ 0xa7e17fdf, 0x37b6, 0x48f5, { 0x86, 0x2c, 0x3a, 0x5f, 0xa1, 0xcf, 0x7b, 0x26 } };

BEGIN_INTERFACE_MAP(EventSink, CCmdTarget)
	INTERFACE_PART(EventSink, __uuidof(_IHooksEvents), Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EventSink message handlers

SCODE EventSink::OnSymbolChanged(BSTR symbol)
{
   
	if(m_pListener) {
		m_pListener->ES_OnSymbolChanged(B2S(symbol));
	}

	return S_OK;
}

SCODE EventSink::OnQuoteChanged(LPTSTR symbol)
{
   if(m_pListener) {
      m_pListener->ES_OnQuoteChanged(symbol);
   }

   return S_OK;
}

SCODE EventSink::OnBarsChanged(long lHandle)
{
   if(m_pListener) {
      m_pListener->ES_OnBarsChanged(lHandle);
   }

   return S_OK;
}

SCODE EventSink::OnBarsReceived(long lHandle)
{
   if(m_pListener) {
      m_pListener->ES_OnBarsReceived(lHandle);
   }

   return S_OK;
}

SCODE EventSink::OnPlaceOrder(LPTSTR xmlOrder)
{

   if(m_pListener) {
      m_pListener->ES_OnPlaceOrder(xmlOrder);
   }

   return S_OK;
}

SCODE EventSink::OnTimeSalesChanged(long lHandle)
{
   if(m_pListener) {
      m_pListener->ES_OnTimeSalesChanged(lHandle);
   }

   return S_OK;
}

